////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
/*
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(cToSvInt(i) );
  }
  return result;
}
*/
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\224\006\000\000\225\006\000\000\227\006\000\000\005\007\000\000\006\007\000\000\010\007"
  "\000\000\004\010\000\000\236\t\000\000\276\t\000\000\363\t\000\000\377\t\000\000\013\n\000\000R\n\000\000^\n\000\000j"
  "\n\000\000\243\n\000\000\257\n\000\000\273\n\000\000h\013\000\000*\015\000\000;\015\000\000G\015\000\000\240\016\000"
  "\000\251\016\000\000$\017\000\000-\017\000\000G\017\000\000\257\017\000\000\270\017\000\000\301\017\000\000\335\017"
  "\000\000\014\021\000\000\216\021\000\000\245\021\000\000\217\024\000\000\223\024\000\000\017\027\000\000\223\027\000"
  "\000\326\027\000\000\311\030\000\000\004\032\000\000\010\032\000\000\211\034\000\000\213\034\000\000\367\034\000\000"
  "\303\035\000\000\304\035\000\000\306\035\000\000\215\036\000\000\247\036\000\000\260\036\000\000\275\036\000\000\343"
  "\036\000\000\n\037\000\000\013\037\000\000\015\037\000\000'\037\000\000(\037\000\000*\037\000\0006\037\000\000O\037"
  "\000\000S\037\000\000U\037\000\000c\037\000\000s\037\000\000t\037\000\000v\037\000\000y\037\000\000}\037\000\000\177"
  "\037\000\000\222\037\000\000\231\037\000\000\233\037\000\000\234\037\000\000\247\037\000\000\256\037\000\000\267\037"
  "\000\000\270\037\000\000\272\037\000\000\344\037\000\000\346\037\000\000\t \000\000\013 \000\000& \000\000/ \000\0007"
  " \000\0008 \000\000: \000\000] \000\000i \000\000r \000\000z \000\000{ \000\000} \000\000\237 \000\000\253 \000\000"
  "\264 \000\000\274 \000\000\275 \000\000\277 \000\000\333 \000\000\347 \000\000\360 \000\000\364 \000\000\371 \000\000"
  "\372 \000\000\374 \000\000\376 \000\000\377 \000\000 !\000\000,!\000\0005!\000\000=!\000\000>!\000\000@!\000\000b!"
  "\000\000n!\000\000w!\000\000\177!\000\000\201!\000\000\203!\000\000\304#\000\000\327#\000\000\021$\000\000\033$\000"
  "\0008$\000\000B$\000\000_$\000\000\?%\000\000\237%\000\000\240%\000\000\242%\000\000\031&\000\000R'\000\000r'\000\000"
  "\316'\000\000\323'\000\000\330'\000\000\335'\000\000\342'\000\000\027(\000\000\034(\000\000D(\000\000\241(\000\000"
  "\313(\000\000\342(\000\000\343(\000\000\345(\000\000\346(\000\000\347(\000\000\352(\000\000\353(\000\000\024)\000\000"
  " )\000\000))\000\0001)\000\0002)\000\0004)\000\0005)\000\0007)\000\0008)\000\000})\000\000\207)\000\000\210)\000\000"
  "\305)\000\000\311)\000\000\315)\000\000\337)\000\000\373)\000\000\375)\000\000\003*\000\000\027*\000\000\031*\000\000"
  "!*\000\0005*\000\000;*\000\000f*\000\000r*\000\000{*\000\000\212*\000\000\236*\000\000\240*\000\000\250*\000\000\274*"
  "\000\000\276*\000\000\306*\000\000\332*\000\000\335*\000\000\340*\000\000\341*\000\000\351*\000\000\352*\000\000\354*"
  "\000\000\016+\000\000K+\000\000l+\000\000\240+\000\000\245+\000\000\263+\000\000\353+\000\000\357+\000\000\375+\000"
  "\0004,\000\0009,\000\000G,\000\000\177,\000\000\204,\000\000\220,\000\000\245,\000\000\254,\000\000\026-\000\000n-"
  "\000\000\201-\000\000\203-\000\000\232-\000\000\234-\000\000\244-\000\000\305-\000\000\322-\000\000\366-\000\000\027."
  "\000\000\037.\000\000+.\000\000,.\000\000O.\000\000V.\000\000z.\000\000\231.\000\000\301.\000\000\340.\000\000\000/"
  "\000\000\035/\000\000K/\000\000o/\000\000\207/\000\000\264/\000\000\323/\000\000\355/\000\000\0350\000\000>0\000\000X"
  "0\000\000Y0\000\000\2050\000\000\2060\000\000\2470\000\000\2640\000\000\2660\000\000\3020\000\000\3240\000\000\3600"
  "\000\000\3710\000\000\0001\000\000\0341\000\000\0351\000\000$1\000\000B1\000\000D1\000\000E1\000\000F1\000\000k1\000"
  "\000n1\000\000u1\000\000\2251\000\000\2261\000\000\2311\000\000\2401\000\000\2761\000\000\2771\000\000\3061\000\000"
  "\3461\000\000\3471\000\000\3561\000\000\0302\000\000+2\000\00012\000\000Q2\000\000f2\000\000\2202\000\000\2442\000"
  "\000\2672\000\000\3412\000\000\3652\000\000\0103\000\00023\000\000F3\000\000Y3\000\000h3\000\000\2043\000\000\2143"
  "\000\000\2233\000\000\2573\000\000\2663\000\000\3313\000\000\3423\000\000\3513\000\000\0174\000\000!4\000\000,4\000"
  "\000H4\000\000K4\000\000R4\000\000n4\000\000v4\000\000}4\000\000\2314\000\000\2364\000\000\2454\000\000\3014\000\000"
  "\3024\000\000\3054\000\000\3144\000\000\3154\000\000\0265\000\000)5\000\000:5\000\000;5\000\000Y5\000\000b5\000\000i5"
  "\000\000\2075\000\000\2175\000\000\2265\000\000\2275\000\000\2655\000\000\2665\000\000\2755\000\000\3335\000\000\3445"
  "\000\000\3535\000\000\3545\000\000\n6\000\000\0356\000\000G6\000\000[6\000\000n6\000\000\2346\000\000\2626\000\000"
  "\3076\000\000\3656\000\000\0137\000\000 7\000\000+7\000\00027\000\000>7\000\000O7\000\000W7\000\000b7\000\000\2057"
  "\000\000\2657\000\000\2747\000\000\2767\000\000\3467\000\000\3747\000\000\0028\000\000\0248\000\000\0328\000\000#8"
  "\000\000*8\000\00068\000\000H8\000\000I8\000\000J8\000\000R8\000\000^8\000\000j8\000\000\2278\000\000\2308\000\000"
  "\2318\000\000\2578\000\000\3338\000\000\3678\000\000\3718\000\000r9\000\000\3319\000\000\010:\000\000d:\000\000\311:"
  "\000\000b;\000\000\302;\000\000 <\000\000\203<\000\000\367<\000\000&=\000\000K=\000\000n=\000\000\223=\000\000\300="
  "\000\000\036>\000\000<>\000\000@>\000\000F>\000\000H>\000\000I>\000\000O>\000\000Q>\000\000R>\000\000\247>\000\000"
  "\017\?\000\000-\?\000\0001\?\000\0007\?\000\0009\?\000\000:\?\000\000@\?\000\000B\?\000\000C\?\000\000\230\?\000\000"
  "\371\?\000\000\027@\000\000\033@\000\000!@\000\000#@\000\000$@\000\000*@\000\000,@\000\000-@\000\000~@\000\000\272@"
  "\000\000\265C\000\000\344C\000\000\324D\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"htt"
  "p://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n\n\n\n<script type=\"text/javascript\" src=\"js/live/createHtml.js"
  "\"></script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErro"
  "rs <= -100) return\n  s.a += '<div class=\"recording_errors\"><img class=\"icon\" src=\"'\n  if (durationDeviation > "
  "300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordin"
  "gErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'Recor"
  "dingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '\" width = \"16px"
  "\" title=\"'\n  if (numErrors == 0) s.a += ''\n  if (numErrors  > 0) s.a += ' ' + String(numErrors)\n  if (numErrors "
  " < 0) s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += ''"
  "\n  s.a += ''\n  s.a += ''\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += ''\n  s.a += ''\n  s.a += ''\n  "
  "s.a += ': '\n  s.a += String(numTsFiles)\n  s.a += '\" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s"
  ".a += '<div class=\"recording_sd_hd\"><img class=\"icon\" src=\"'\n  s.a += hdsd\n  s.a += 'd.png\" width = \"25px\" "
  "title=\"'\n  s.a += toolTip\n  s.a += '\" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) "
  "{\n    s.a += '<a href=\"http://www.imdb.com/find\?s=all&q='\n    if (name.startsWith(\"%\") ) {\n      s.a += name.s"
  "ubstr(1)\n    } else {\n      s.a += name\n    }\n  } else {\n    s.a += '<a href=\"https://www.imdb.com/title/'\n   "
  " s.a += im_db\n  }\n  s.a += \n   '\" target=\"_blank\"><img class=\"icon\" src=\"imdb.png\" title=\"\"/></a>'\n}\n\n"
  "\nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bo"
  "ttomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class=\"action leftcol ${bottomrow}\">`\n  if (obj[1].leng"
  "th != 0) {\n    s.a += '<a href=\"edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '\"><img class=\"ic"
  "on\" src=\"\" title=\"\" />'\n  } else {\n    s.a += '<a href=\"edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n  "
  "  s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  }\n  s.a += '</a>'\n  s.a += '<a href=\"searchresults.htm"
  "l\?searchplain='\n  s.a += obj[11]\n  s.a += '\"><img class=\"icon\" src=\"\" title=\"\"/></a>'\n  IMDBS(s, obj[2], o"
  "bj[11])\n  s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class=\"t"
  "d-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\"><a href=\"schedule.html\?channel=`\n    s.a += obj[9]"
  "\n    s.a += '\">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n    s.a += `<td class"
  "=\"enlarge-image ${bottomrow}\">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n"
  "    s.a += '</td>'\n  s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\">`\n  s.a +="
  " obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class=\"rightcol ${bott"
  "omrow}\"><div class=\"withmargin\">`\n// first line: link to channel, times, channel\n  s.a += '<div class=\"margin-b"
  "ottom display-xs\">'\n  if (obj[9] > 0) {\n    s.a += '<a href=\"schedule.html\?channel='\n    s.a += obj[9]\n    s.a"
  " += '\">'\n  }\n  s.a += '<span class=\"normal-font\">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s"
  ".a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link t"
  "o event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '', '', '', '', '"
  "', 1)\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s."
  "a = \"\"\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, c"
  "ol_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_dur"
  "ation, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFi"
  "les) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s"
  ".a += ' class=\"leftcol '\n  s.a += bottomrow\n  s.a += '\">'\n  if (archiveDescr.length != 0) {\n    s.a += '</td><t"
  "d class=\"action '\n    s.a += bottomrow\n    s.a += '\"> <img class=\"icon\" src=\"\" alt=\"on dvd\" title=\" />'\n "
  "   s.a += archiveDescr\n    s.a += '/>'\n  } else {\n    s.a += '<br/><table><tr><td class=\"noborder\">'\n    addErr"
  "orIcon(s, errors, durationDeviation, duration, numTsFiles)\n    s.a += '</td><td class=\"noborder\">'\n    addHdSdIco"
  "n(s, hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n  }\n  s.a += '</td><td class=\"td-hidden-xs '\n  s.a += "
  "bottomrow\n  s.a += '\"><div class=\"hidden-xs recording_day\">'\n  s.a += day_time_duration\n  s.a += '</div></td><t"
  "d class=\"rightcol '\n  s.a += bottomrow\n  s.a += '\">'\n  addColEventRec(s, day_time_duration, 'recording_', id, na"
  "me, folder, short_text, description, '', '')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bo"
  "ttomrow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, error"
  "s, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, size, numTsFiles) {"
  "\n  const s = Object.create(null)\n  s.a = \"\"\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDe"
  "scr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, n"
  "ame, short_text, description, durationDeviation, folder, duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n\n\n<"
  "link rel=\"stylesheet\" type=\"text/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href="
  "\"\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src"
  "=\"js/live/header.js\"></script>\n<script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-"
  "- start of fixed page header -->\n<div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"pad"
  "ding\" style=\"display: none\"></div>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_heade"
  "r\">\n<a href=\"\">\n<img src=\"\" alt=\"VDR Live!\" class=\"logo\" /></a>\n</div>\n<div style=\"clear: both\"></div>"
  "\n\n\n\nstyle=\"visibility: hidden\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\" style=\"width: %\"></div><"
  "/div>\n\n\n\n<a id=\"\"  href=\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\" /></a> \n\n\n<a href=\"http://www.imd"
  "b.com/find\?s=all&q=\"\n<a href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\"  /></a> \n"
  "\n\n<a href=\"stream.html\?channelid_str=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"playlist.m3u\?channel_str"
  "=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n<a href=\"playlist.m3u\?recid=\"><img src=\"\" alt=\"\"  /> </a>\n\n\n\n\t"
  "\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\t<a href=\"edit_timer.html\?timeri"
  "d=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script type=\"text/javascript\" src=\"js/mootools/mootools.v1.11.js\""
  "></script>\n\t<script type=\"text/javascript\" src=\"js/live/liveajax.js\"></script>\n\t<script type=\"text/javascrip"
  "t\" src=\"js/live/infowin.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/hinttips.js\"></script>\n"
  "\t<script type=\"text/javascript\" src=\"js/live/browserwin.js\"></script>\n\t<script type=\"text/javascript\" src=\""
  "js/live/pageenhance.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar liveEnhanced = new PageEnhance({"
  "\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '',\n\t\t\t\t\terrorM"
  "sg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src=\"\" alt=\"\"> ',\n\t\t\t\t\terrorMsg: "
  "'<img src=\"\" alt=\"\"> '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n\t<script type=\"text/javascript\" src=\"js/live/vd"
  "r_status.js\"></script>\n\t<script type=\"text/javascript\"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'info"
  "box');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request();\n\t\t});\n\t\twindow.addEvent('unload',"
  " function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n\n\n\n<div id=\"infobox\">\n\t<div class=\"stat"
  "uscontent\">\n\t\t<div class=\"st_header\">\n\t\t\t<div id=\"infobox_caption\" class=\"caption\"></div>\n\t\t\t<div i"
  "d=\"infobox_timenow\" class=\"now\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_content\">\n\t\t\t<div id=\"infobox_"
  "name\" class=\"name\"></div>\n\t\t\t<div id=\"infobox_duration\" class=\"duration\">--:--</div>\n\t\t</div>\n\t\t<div"
  " class=\"st_controls\">\n\t\t\t<div class=\"st_update\">\n\t\t\t\t<a href=\"javascript:InfoBox.toggleUpdate()\" ><img"
  " id=\"statusReloadBtn\" src=\"\" alt=\"\" /></a>\n\t\t\t</div>\n\t\t\t<div id=\"infobox_recording_buttons\" style=\"d"
  "isplay: none\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div id=\"infobox_channel_butt"
  "ons\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"st_pbar\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>"
  "\n\t<div style=\"display: none;\">\n\t\t<span id=\"__infobox_request_err\"></span>\n\t\t<span id=\"__infobox_update_e"
  "rr\"></span>\n\t</div>\n</div>\n\n\n\n\t\n\t  \n\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\""
  "  /></a>\n\t\n\t\n\t\t\n<img data-src=\"img/transparent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n\n\t\t"
  "\t\t\t<script class=\"injectIcons\">\n\t\t\t\t\tinjectHdSdIcon(\"icons-\", \"\", \"\")\n\t\t\t\t\t</script>\n\t\t<td "
  "class=\"action leftcol \"></td>\n\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \">\n\t\t\t\t\t\t<a href"
  "=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\"  /></a></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t"
  "\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \">\n\t\t\t\n\t\t</td>\n\n\n\n\t<div class=\"epg_descript"
  "ion\" id=\"\">\n\t\t<div class=\"station\">\n\t\t\t<div class=\"boxheader\">\n\n<div>\n<div class = \"caption\">\n  <"
  "a id=\"_epg_m\"     class = \"active\"   onclick=\"displayEPG('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive"
  "\" onclick=\"displayScraper('')\"></a>\n| <a id=\"_actors_m\"  class = \"inactive\" onclick=\"displayActors('')\" ></"
  "a>\n| <a id=\"_artwork_m\" class = \"inactive\" onclick=\"displayArtwork('')\" ></a>\n</div>\n<div class=\"caption\">"
  "</div>\n</div>\n                        </div>\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div class=\"epg_t"
  "ools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div class=\"epg_info\">\n\t\t\t\t<div class=\"info\">\n\t\t\t\t\t<div class="
  "\"duration\">\n\t\t\t\t\t\t<span title=\"\"></span> / <span title=\"\"></span>\n\t\t\t\t\t\t<div class=\"progress\"><"
  "div></div></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<div class=\"time\">\n              <span class=\"bold\"></span>\n     "
  "       \n              <div class=\"channel\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<div class=\"title\"></div>\n\t\t\t"
  "\t\t<div class=\"short\"></div>\n\t\t\t\t\t<div class=\"description\" id=_description>\n\t\t\t\t\t<span id = \"_epg_i"
  "mage\" class=\"epg_images\">\n         <a href=\"/epgimages/\" target=\"_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/"
  "\" class=\"epg_image\"/>\n         </a>\n    <a href=\"/tvscraper/\" target=\"_blank\">\n\t    <img src=\"/tvscraper/"
  "\" class=\"epg_image\"/>\n    </a>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscraper/"
  "\" class=\"epg_image\"/>\n      </a>\n      <a href=\"/recimages//\" target=\"_blank\">\n\t\t\t\t<img src=\"/recimage"
  "s//\" class=\"epg_image\"/>\n      </a>\n\t\t\t\t\t</span> \n\n\n<div id = '_scraper' hidden>\n  <div class=\"scraper"
  "_list\">         </div>\n  <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\"> SE </div>\n    <div "
  "class=\"scraper_list\">   </div>\n      <div class=\"scraper_list\">  / </div>\n    <div class=\"scraper_list\"> </di"
  "v>\n      <div class=\"scraper_list\"> </div>\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>"
  "\n      <div class=\"scraper_list\"></div>\n      <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n     "
  "   <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n "
  "     <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      </table>\n  <div class=\""
  "scraper_list\">        </div>\n  <div class=\"scraper_list\">       </div>\n  <div class=\"scraper_list\">         </"
  "div>\n  <div class=\"scraper_list\"><a href =\"\" target=\"_blank\"></a></div>\n  <div class=\"scraper_list\">   </di"
  "v>\n  <div class=\"scraper_list\">        </div>\n  <div class=\"scraper_list\">     </div>\n  <div class=\"scraper_l"
  "ist\">  / </div>\n\n    <div class=\"scraper_list\">\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\""
  ">  </a>\n    </div>\n\n    <div class=\"scraper_list\">         </div>\n    <div class=\"scraper_list\">        </div"
  ">\n\n    <div class=\"scraper_list\"> </div>\n    <div class=\"scraper_list\">         </div>\n\n    <div class=\"scr"
  "aper_list\"></div>\n    <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr"
  ">\n        <tr>\n          <td class=\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n        <tr>\n     "
  "     <td class=\"cast_role\">  </td>\n          <td>  </td>\n        </tr>\n  </table>\n</div>\n\n<div id = '_actors'"
  " hidden>\n<table>\n      <tr>\n    <td>\n      <a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscra"
  "per/\" alt=\": \" class=\"actor\" />\n      </a>\n    </td>\n      </tr>\n      <tr></tr>\n    </tr>\n    <tr></tr>\n"
  "</table>\n</div>\n\n<div id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '_epg'>\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t"
  "</div>\n\t\t</div>\n\t</div>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\"_blank\">\n    <img src=\"/tvscraper/\" "
  "class=\"artwork\" />\n  </a>\n\n\n\t<div class=\"epg_description\" id=\"aboutBox\">\n\t\t<div class=\"station\">\n\t"
  "\t\t<div class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n\t\t</div>\n\t\t<div class=\"epg_content"
  "\">\n\t\t\t<div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">:"
  "</div>\n\t\t\t\t<div class=\"about_right\">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t"
  "\t\t\t<div class=\"about_right\">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t"
  "\t\t<div class=\"about_right\">Markus Ehrnsperger (MarkusE @ <a href=\"https://www.vdr-portal.de\">VDR Portal</a>)</d"
  "iv>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Jasmin Jessich (jasminj)</div>\n\t"
  "\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Dieter Hametner (tadi)</div>\n\t\t\t\t<di"
  "v class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Christian Wieninger (winni)</div>\n\t\t\t\t<div cl"
  "ass=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div"
  " class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"a"
  "bout_right\"></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<d"
  "iv class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">EPGsearch:</div>\n\t\t\t\t<di"
  "v class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a h"
  "ref=\"https://github.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<d"
  "iv class=\"about_left\">Streamdev server:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\""
  " src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/vdr-plugin-streamde"
  "v\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">tvscraper:</div>\n\t\t\t\t<div cl"
  "ass=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href="
  "\"https://github.com/MarkusEh/vdr-plugin-tvscraper\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class"
  "=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">Movie information provided by <a targ"
  "et=\"_blank\" href=\"https://www.themoviedb.org/\">TMDB</a>. This product uses the TMDB API but is not endorsed or ce"
  "rtified by TMDB</div>\n\t\t\t\t<div class=\"about_line\">Information provided by TheTVDB.com. Please consider <a targ"
  "et=\"_blank\" href=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7"
  "kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr"
  "0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9"
  "Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div>"
  "</div></div></div>\n\t\t\t\t<div class=\"about_line\">:<br/>\n\t\t\t\t\t<a target=\"_blank\" href=\"https://github.co"
  "m/MarkusEh/vdr-plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="
  "\"about_head\"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[42]; // \n\n
  reply.out() << _tntChunks[45]; // \n
  reply.out() << _tntChunks[46]; // \n\n
  reply.out() << _tntChunks[53]; // \n
  reply.out() << _tntChunks[54]; // \n\n
  reply.out() << _tntChunks[56]; // \n
  reply.out() << _tntChunks[57]; // \n\n
  reply.out() << _tntChunks[64]; // \n
  reply.out() << _tntChunks[65]; // \n\n
  reply.out() << _tntChunks[76]; // \n
  reply.out() << _tntChunks[77]; // \n\n
  reply.out() << _tntChunks[85]; // \n
  reply.out() << _tntChunks[86]; // \n\n
  reply.out() << _tntChunks[91]; // \n
  reply.out() << _tntChunks[92]; // \n\n
  reply.out() << _tntChunks[97]; // \n
  reply.out() << _tntChunks[98]; // \n\n
  reply.out() << _tntChunks[104]; // \n
  reply.out() << _tntChunks[105]; // \n\n
  reply.out() << _tntChunks[112]; // \n
  reply.out() << _tntChunks[113]; // \n\n
  reply.out() << _tntChunks[118]; // \n\n
  reply.out() << _tntChunks[119]; // \n\n
  reply.out() << _tntChunks[129]; // \n
  reply.out() << _tntChunks[130]; // \n\n
  reply.out() << _tntChunks[145]; // \n
  reply.out() << _tntChunks[146]; // \n\n
  reply.out() << _tntChunks[190]; // \n
  reply.out() << _tntChunks[191]; // \n\n
  reply.out() << _tntChunks[365]; // \n
  reply.out() << _tntChunks[366]; // \n
  reply.out() << _tntChunks[370]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 65 "pageelems.ecpp"

const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";

  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration, numTsFiles) {\n  if (numErrors <= -100) return\n  s.a += '<div class="recording_errors"><img class="icon" src="
#line 74 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[6]; // '\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '" width = "16px" title="'\n  if (numErrors == 0) s.a += '
#line 83 "pageelems.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[7]; // '\n  if (numErrors  > 0) s.a += '
#line 84 "pageelems.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[8]; //  ' + String(numErrors)\n  if (numErrors  < 0) s.a += '
#line 85 "pageelems.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[9]; // '\n  s.a += '
#line 86 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[10]; // '\n  s.a += '
#line 87 "pageelems.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[11]; // '\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += '
#line 91 "pageelems.ecpp"
  reply.sout() << (tr("min"));
  reply.out() << _tntChunks[12]; // '\n  s.a += '
#line 92 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[13]; // '\n  s.a += '
#line 93 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[14]; // '\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += '
#line 97 "pageelems.ecpp"
  reply.sout() << (tr("h"));
  reply.out() << _tntChunks[15]; // '\n  s.a += '
#line 98 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[16]; // '\n  s.a += '
#line 99 "pageelems.ecpp"
  reply.sout() << (tr("Number of ts files"));
  reply.out() << _tntChunks[17]; // '\n  s.a += ': '\n  s.a += String(numTsFiles)\n  s.a += '" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<div class="recording_sd_hd"><img class="icon" src="
#line 106 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[18]; // '\n  s.a += hdsd\n  s.a += 'd.png" width = "25px" title="'\n  s.a += toolTip\n  s.a += '" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href="http://www.imdb.com/find\?s=all&q='\n    if (name.startsWith("%") ) {\n      s.a += name.substr(1)\n    } else {\n      s.a += name\n    }\n  } else {\n    s.a += '<a href="https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '" target="_blank"><img class="icon" src="
#line 126 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[19]; // imdb.png" title="
#line 126 "pageelems.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[20]; // "/></a>'\n}\n\n
  reply.out() << _tntChunks[21]; // \nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class="action leftcol ${bottomrow}">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '"><img class="icon" src="
#line 155 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record_timer.png") );
  reply.out() << _tntChunks[22]; // " title="
#line 155 "pageelems.ecpp"
  reply.sout() << (tr("Edit timer"));
  reply.out() << _tntChunks[23]; // " />'\n  } else {\n    s.a += '<a href="edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '"><img class="icon" src="
#line 159 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[24]; // " title="
#line 159 "pageelems.ecpp"
  reply.sout() << (tr("Record this"));
  reply.out() << _tntChunks[25]; // " />'\n  }\n  s.a += '</a>'\n
#line 162 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << _tntChunks[26]; //   s.a += '<a href="searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '"><img class="icon" src="
#line 165 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[27]; // " title="
#line 165 "pageelems.ecpp"
  reply.sout() << (tr("Search for repeats."));
  reply.out() << _tntChunks[28]; // "/></a>'\n
#line 166 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[29]; //   IMDBS(s, obj[2], obj[11])\n
#line 168 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[30]; //   s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin"><a href="schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n
#line 179 "pageelems.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[31]; //     s.a += `<td class="enlarge-image ${bottomrow}">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 181 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[32]; // ');\n    s.a += '</td>'\n
#line 183 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[33]; //   s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class="rightcol ${bottomrow}"><div class="withmargin">`\n// first line: link to channel, times, channel\n  s.a += '<div class="margin-bottom display-xs">'\n  if (obj[9] > 0) {\n    s.a += '<a href="schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '">'\n  }\n  s.a += '<span class="normal-font">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '
#line 206 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[34]; // ', '
#line 206 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[35]; // ', '', '', '', 1)\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = ""\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class="leftcol '\n  s.a += bottomrow\n  s.a += '">
#line 223 "pageelems.ecpp"
  reply.sout() << ( tr("Existing Recording:") );
  reply.out() << _tntChunks[36]; // '\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class="action '\n    s.a += bottomrow\n    s.a += '"> <img class="icon" src="
#line 227 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[37]; // " alt="on dvd" title=" />'\n    s.a += archiveDescr\n    s.a += '/>'\n
#line 230 "pageelems.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[38]; //   } else {\n    s.a += '<br/><table><tr><td class="noborder">'\n    addErrorIcon(s, errors, durationDeviation, duration, numTsFiles)\n    s.a += '</td><td class="noborder">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n
#line 239 "pageelems.ecpp"

#endif

  reply.out() << _tntChunks[39]; //   }\n  s.a += '</td><td class="td-hidden-xs '\n  s.a += bottomrow\n  s.a += '"><div class="hidden-xs recording_day">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class="rightcol '\n  s.a += bottomrow\n  s.a += '">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '
#line 250 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[40]; // ', '
#line 250 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[41]; // ')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, size, numTsFiles) {\n  const s = Object.create(null)\n  s.a = ""\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration, numTsFiles)\n  return s.a\n}\n\n\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[43]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 267 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[44]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[47]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 281 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo()
		|| (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox())) {

  reply.out() << _tntChunks[48]; // <div class="page_header">\n
#line 286 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[49]; // <a href="
#line 289 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[50]; // ">\n<img src="
#line 290 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[51]; // " alt="VDR Live!" class="logo" /></a>\n
#line 291 "pageelems.ecpp"

		}

#line 294 "pageelems.ecpp"
if (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 294 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 294 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 294 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[52]; // </div>\n<div style="clear: both"></div>\n
#line 297 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 308 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[55]; // style="visibility: hidden"
#line 308 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 319 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[58]; // <div class="
#line 324 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[59]; // "><div class="__elapsed" 
#line 324 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[60]; // id="
#line 324 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[61]; // " 
#line 324 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[62]; // style="width: 
#line 324 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[63]; // %"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 338 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[66]; // <a 
#line 338 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[67]; // id="
#line 338 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[68]; // " 
#line 338 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 338 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 338 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 338 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[69]; //  href="vdr_request/
#line 338 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[70]; // \?param=
#line 338 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[71]; // " 
#line 338 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 338 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 338 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 338 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[72]; //  
#line 338 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[73]; // ><img src="
#line 338 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[74]; // " alt="
#line 338 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[75]; // " /></a> 
#line 338 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 348 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[78]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 352 "pageelems.ecpp"
  reply.sout() << ( (!title.empty() && title[0] == '%')?StringUrlEncode(cSv(title).substr(1)):StringUrlEncode(title) );
  reply.out() << _tntChunks[79]; // "\n
#line 353 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[80]; // <a href="http://www.imdb.com/title/
#line 354 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[81]; // "\n
#line 355 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[82]; //  target="_blank"><img src="
#line 356 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[83]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 356 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 356 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 356 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[84]; //  /></a> 
#line 356 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 365 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[87]; // <a href="stream.html\?channelid_str=
#line 368 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[88]; // "><img src="
#line 368 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[89]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 368 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 368 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 368 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[90]; //  /></a>\n
#line 369 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 380 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[93]; // <a href="playlist.m3u\?channel_str=
#line 383 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[94]; // "><img src="
#line 383 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[95]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 383 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 383 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 383 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[96]; //  /></a>\n
#line 384 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 396 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{

  reply.out() << _tntChunks[99]; // <a href="playlist.m3u\?recid=
#line 399 "pageelems.ecpp"
  reply.sout() << ( recid );
  reply.out() << _tntChunks[100]; // "><img src="
#line 399 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[101]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 399 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 399 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this recording into media player.")));
#line 399 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[102]; //  /> 
#line 399 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[103]; // </a>\n
#line 400 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 412 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[106]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 419 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 419 "pageelems.ecpp"
    _tnt_cq7.add( "imgName", ("record_timer.png"));
#line 419 "pageelems.ecpp"
    _tnt_cq7.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 419 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[107]; // \n
#line 420 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[108]; // \t\t<a href="edit_timer.html\?epgid=
#line 424 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[109]; // "><img src="
#line 424 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[110]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 424 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 424 "pageelems.ecpp"
    _tnt_cq8.add( "text", (tr("Record this")));
#line 424 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[111]; //  /></a>\n
#line 425 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[114]; // \t<a href="edit_timer.html\?timerid=
#line 437 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[115]; // "><img src="
#line 437 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[116]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 437 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 437 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Edit timer")));
#line 437 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[117]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 444 "pageelems.ecpp"

	if (LiveSetup().GetUseAjax()) {

  reply.out() << _tntChunks[120]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 457 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[121]; // ',\n\t\t\t\t\terrorMsg: '
#line 458 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[122]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 461 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[123]; // " alt=""> 
#line 461 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[124]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 462 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[125]; // " alt=""> 
#line 462 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[126]; // '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n
#line 466 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[127]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 473 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[128]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 479 "pageelems.ecpp"

		}

#line 482 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[131]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 493 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[132]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 502 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 502 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Toggle updates on/off.")));
#line 502 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[133]; // ><img id="statusReloadBtn" src="
#line 502 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[134]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 505 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 505 "pageelems.ecpp"
    _tnt_cq11.add( "action", ("stop_recording"));
#line 505 "pageelems.ecpp"
    _tnt_cq11.add( "id", ("infobox_stop"));
#line 505 "pageelems.ecpp"
    _tnt_cq11.add( "image", ("stop.png"));
#line 505 "pageelems.ecpp"
    _tnt_cq11.add( "tip", (tr("stop playback")));
#line 505 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[135]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 506 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 506 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("play_recording"));
#line 506 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_play"));
#line 506 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("play.png"));
#line 506 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("resume playback")));
#line 506 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[136]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 507 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 507 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("pause_recording"));
#line 507 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_pause"));
#line 507 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("pause.png"));
#line 507 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("pause playback")));
#line 507 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[137]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 508 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 508 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("rwd_recording"));
#line 508 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_rwd"));
#line 508 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("rwd.png"));
#line 508 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("fast rewind")));
#line 508 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[138]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 509 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 509 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("ffw_recording"));
#line 509 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_ffw"));
#line 509 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("ffw.png"));
#line 509 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast forward")));
#line 509 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[139]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 512 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 512 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("switch_channel"));
#line 512 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_prevchan"));
#line 512 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("one_downarrow.png"));
#line 512 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("previous channel")));
#line 512 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[140]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 513 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 513 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 513 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_nextchan"));
#line 513 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_uparrow.png"));
#line 513 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("next channel")));
#line 513 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 516 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 516 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_elapsed"));
#line 516 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 521 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[143]; // </span>\n\t\t<span id="__infobox_update_err">
#line 522 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[144]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 539 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[147]; // \t
  // <& pageelems.event_timer ...
  { 
#line 548 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 548 "pageelems.ecpp"
    _tnt_cq19.add( "epgid", (epgid));
#line 548 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[148]; // \n
#line 549 "pageelems.ecpp"

  if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[149]; // \t  
  // <& pageelems.ajax_action_href ...
  { 
#line 552 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "action", "switch_channel");
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "alt", "");
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "image", "zap.png");
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "param", (channelId));
#line 552 "pageelems.ecpp"
    _tnt_cq20.add( "tip", (tr("Switch to this channel.")));
#line 552 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[150]; // \n
#line 553 "pageelems.ecpp"

	} if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[151]; // \t<a href="searchresults.html\?searchplain=
#line 556 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[152]; // "><img src="
#line 556 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[153]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 556 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 556 "pageelems.ecpp"
    _tnt_cq21.add( "text", (tr("Search for repeats.")));
#line 556 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[154]; //  /></a>\n
#line 557 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[155]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 561 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 561 "pageelems.ecpp"
    _tnt_cq22.add( "channelId", (channelId));
#line 561 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[156]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 562 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 562 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 562 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[157]; // \n
#line 563 "pageelems.ecpp"

		}
	if (eventId != 0) {
    /* Need to lock here channels also, because CreateEpgInfo will lock
     * it also and this will result in a wrong lock order */
    LOCK_CHANNELS_READ;
    LOCK_SCHEDULES_READ;
    EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
    const cEvent* event = epgEvent->Event();
    const cChannel* channel = event?Channels->GetByChannelID(event->ChannelID()):nullptr;
    cGetScraperVideo getScraperVideo(event, NULL);
    bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
    if (scraperDataAvailable) {
      int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
      char sdhd = video_SD_HD == 0 ? 's': video_SD_HD == 1 ? 'h': video_SD_HD == 2 ? 'u' : 0;


  reply.out() << _tntChunks[158]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 580 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 580 "pageelems.ecpp"
    _tnt_cq24.add( "s_IMDB_ID", (s_IMDB_ID));
#line 580 "pageelems.ecpp"
    _tnt_cq24.add( "title", (title));
#line 580 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[159]; // \n
#line 581 "pageelems.ecpp"
 if (detail > 1) {

  reply.out() << _tntChunks[160]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 583 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[161]; // "></span>\n
  reply.out() << _tntChunks[162]; // \n
#line 587 "pageelems.ecpp"
 if (sdhd) { 
  reply.out() << _tntChunks[163]; // \t\t\t\t\t<script class="injectIcons">\n\t\t\t\t\tinjectHdSdIcon("icons-
#line 589 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[164]; // ", "
#line 589 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[165]; // ", "
#line 589 "pageelems.ecpp"
  reply.sout() << ((channel&&channel->Name())?channel->Name():"");
  reply.out() << _tntChunks[166]; // ")\n\t\t\t\t\t</script>\n
#line 591 "pageelems.ecpp"

				}
		  }
		}
		}
	}
	else { // table output

  reply.out() << _tntChunks[167]; // \t\t<td class="action leftcol 
#line 599 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[168]; // ">
  // <& pageelems.event_timer ...
  { 
#line 599 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 599 "pageelems.ecpp"
    _tnt_cq25.add( "epgid", (epgid));
#line 599 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[169]; // </td>\n
#line 600 "pageelems.ecpp"

    if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[170]; // \t\t<td class="action 
#line 603 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[171]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 603 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "action", "switch_channel");
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "alt", "");
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "image", "zap.png");
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "param", (channelId));
#line 603 "pageelems.ecpp"
    _tnt_cq26.add( "tip", (tr("Switch to this channel.")));
#line 603 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[172]; // </td>\n\t\t
#line 604 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) { 
  reply.out() << _tntChunks[173]; // \t\t<td class="action 
#line 605 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[174]; // ">\n\t\t\t
#line 606 "pageelems.ecpp"
 if (eventId) { 
  reply.out() << _tntChunks[175]; // \t\t\t<a href="searchresults.html\?searchplain=
#line 607 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[176]; // "><img src="
#line 607 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[177]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 607 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 607 "pageelems.ecpp"
    _tnt_cq27.add( "text", (tr("Search for repeats.")));
#line 607 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[178]; //  /></a></td>\n\t\t
#line 608 "pageelems.ecpp"
 } } 
  reply.out() << _tntChunks[179]; // \t\t<td class="action 
#line 609 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[180]; // ">
#line 609 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 609 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 609 "pageelems.ecpp"
    _tnt_cq28.add( "channelId", (channelId));
#line 609 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq28);
    // &>
  }
#line 609 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[181]; // </td>\n\t\t
#line 610 "pageelems.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[182]; // \t\t<td class="action 
#line 611 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[183]; // ">
#line 611 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 611 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 611 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 611 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 611 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[184]; // </td>\n\t\t
#line 612 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[185]; // \t\t<td class="action 
#line 613 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[186]; // ">\n
#line 614 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[187]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 617 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 617 "pageelems.ecpp"
    _tnt_cq30.add( "s_IMDB_ID", (s_IMDB_ID));
#line 617 "pageelems.ecpp"
    _tnt_cq30.add( "title", (title));
#line 617 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq30);
    // &>
  }
  reply.out() << _tntChunks[188]; // \n
#line 618 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[189]; // \t\t</td>\n
#line 622 "pageelems.ecpp"

	} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[192]; // \t<div class="epg_description" id="
#line 651 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[193]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 656 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent;
if (iepgEvent) epgEvent = *static_cast<EpgInfoPtr*>((void *)iepgEvent);


sScraperMovieOrTv scraperMovieOrTv;
cGetScraperVideo getScraperVideo(static_cast<cEvent *>((void *)ievent), static_cast<cRecording *>((void *)irecording));
scraperMovieOrTv.found = getScraperVideo.call(LiveSetup().GetPluginScraper());
if (scraperMovieOrTv.found) {
  tvType type = getScraperVideo.m_scraperVideo->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = getScraperVideo.m_scraperVideo->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}
std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = getScraperVideo.m_scraperVideo->getCharacters(false);
  scraperMovieOrTv.posters = getScraperVideo.m_scraperVideo->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = getScraperVideo.m_scraperVideo->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = getScraperVideo.m_scraperVideo->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = getScraperVideo.m_scraperVideo->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = getScraperVideo.m_scraperVideo->getEpisodeNumber();
    scraperMovieOrTv.episode.season = getScraperVideo.m_scraperVideo->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[194]; // <div class = "caption">\n  <a id="
#line 744 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[195]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 744 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[196]; // ')" >
#line 744 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[197]; // </a>\n| <a id="
#line 745 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[198]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 745 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[199]; // ')">
#line 745 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[200]; // </a>\n| <a id="
#line 746 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[201]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 746 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[202]; // ')" >
#line 746 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[203]; // </a>\n| <a id="
#line 747 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[204]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 747 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[205]; // ')" >
#line 747 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[206]; // </a>\n</div>\n
#line 749 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[207]; // <div class="caption">
#line 752 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[208]; // </div>\n
#line 753 "pageelems.ecpp"

}

  reply.out() << _tntChunks[209]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 761 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "archived", (archived));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "detail", (2));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "filter", (filter));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "flat", (flat));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "history_num_back", (history_num_back));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "id", (boxId));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "sort", (sort));
#line 761 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 761 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[210]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info">\n\t\t\t\t\t<div class="duration">\n
#line 766 "pageelems.ecpp"

if (epgEvent && epgEvent->EventDuration() >= 0) {  // recording

  reply.out() << _tntChunks[211]; // \t\t\t\t\t\t<span title="
#line 769 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[212]; // ">
#line 769 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[213]; // </span> / <span title="
#line 769 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[214]; // ">
#line 769 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[215]; // </span>\n
#line 770 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[216]; // \t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 774 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 774 "pageelems.ecpp"
    _tnt_cq32.add( "progress", (elapsed));
#line 774 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[217]; // </div></div>\n
#line 775 "pageelems.ecpp"

}

  reply.out() << _tntChunks[218]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="time">\n
#line 780 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[219]; //               <span class="bold">
#line 781 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[220]; // </span>\n
#line 782 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[221]; //             
#line 783 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[222]; // \n
#line 784 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[223]; //               <div class="channel">
#line 785 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[224]; // </div>\n
#line 786 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[225]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="title">
#line 788 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[226]; // </div>\n\t\t\t\t\t<div class="short">
#line 789 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[227]; // </div>\n\t\t\t\t\t<div class="description" id=
#line 790 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[228]; // _description>\n\t\t\t\t\t<span id = "
#line 791 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[229]; // _epg_image" class="epg_images">\n
#line 792 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[230]; //          <a href="/epgimages/
#line 796 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[231]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 797 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[232]; // " class="epg_image"/>\n         </a>\n
#line 799 "pageelems.ecpp"

	}
	if(!epgImage.empty() ) {

  reply.out() << _tntChunks[233]; //     <a href="/tvscraper/
#line 803 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[234]; // " target="_blank">\n\t    <img src="/tvscraper/
#line 804 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[235]; // " class="epg_image"/>\n    </a>\n
#line 806 "pageelems.ecpp"
   if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) {

  reply.out() << _tntChunks[236]; //       <a href="/tvscraper/
#line 807 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[237]; // " target="_blank">\n        <img src="/tvscraper/
#line 808 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[238]; // " class="epg_image"/>\n      </a>\n
#line 810 "pageelems.ecpp"

    }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
	} else {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[239]; //       <a href="/recimages/
#line 819 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[240]; // /
#line 819 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[241]; // " target="_blank">\n\t\t\t\t<img src="/recimages/
#line 820 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[242]; // /
#line 820 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[243]; // " class="epg_image"/>\n      </a>\n
#line 822 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[244]; // \t\t\t\t\t</span> 
  reply.out() << _tntChunks[245]; // \n\n
  reply.out() << _tntChunks[246]; // \n<div id = '
#line 829 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[247]; // _scraper' hidden>\n
#line 830 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[248]; //   <div class="scraper_list">
#line 833 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[249]; //          
#line 833 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[250]; // </div>\n
#line 834 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[251]; //   <div class="scraper_list">
#line 837 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[252]; //  
#line 837 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[253]; // </div>\n
#line 838 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[254]; //     <div class="scraper_list">
#line 842 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[255]; //  S
#line 842 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.season )) );
  reply.out() << _tntChunks[256]; // E
#line 842 "pageelems.ecpp"
  reply.sout() << ( cSv(cToSvInt(scraperMovieOrTv.episode.number)) );
#line 842 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?concat("A", cToSvInt(scraperMovieOrTv.episode.absoluteNumber)):"");
  reply.out() << _tntChunks[257]; //  
#line 842 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.name );
  reply.out() << _tntChunks[258]; // </div>\n    <div class="scraper_list">
#line 843 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[259]; //    
#line 843 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[260]; // </div>\n
#line 844 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[261]; //       <div class="scraper_list">
#line 847 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[262]; //  
#line 847 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average) );
  reply.out() << _tntChunks[263]; //  / 
#line 847 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[264]; // </div>\n
#line 848 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[265]; //     <div class="scraper_list">
#line 851 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[266]; //  
#line 851 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[267]; // </div>\n
#line 852 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[268]; //       <div class="scraper_list">
#line 853 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[269]; //  
#line 853 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.episode.runtime*60) );
  reply.out() << _tntChunks[270]; // </div>\n
#line 854 "pageelems.ecpp"
   }

#line 855 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[271]; //       <a href="https://www.imdb.com/title/
#line 856 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[272]; // " target="_blank"> 
#line 856 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[273]; //  </a>\n
#line 857 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[274]; //       <div class="scraper_list">
#line 866 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[275]; // </div>\n      <table>\n
#line 868 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 869 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[276]; //       <tr>\n        <td class="cast_role"> 
#line 871 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[277]; //  </td>\n        <td> 
#line 872 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[278]; //  </td>\n      </tr>\n
#line 874 "pageelems.ecpp"
   }

#line 875 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 876 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[279]; //       <tr>\n        <td class="cast_role"> 
#line 878 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[280]; //  </td>\n        <td> 
#line 879 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[281]; //  </td>\n      </tr>\n
#line 881 "pageelems.ecpp"
   }

#line 882 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 883 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[282]; //       <tr>\n        <td class="cast_role"> 
#line 885 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[283]; //  </td>\n        <td> 
#line 886 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[284]; //  </td>\n      </tr>\n
#line 888 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[285]; //       </table>\n
#line 890 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[286]; //   <div class="scraper_list">
#line 895 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[287]; //         
#line 895 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[288]; // </div>\n
#line 896 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[289]; //   <div class="scraper_list">
#line 897 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[290]; //        
#line 897 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[291]; // </div>\n  <div class="scraper_list">
#line 898 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[292]; //          
#line 898 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[293]; // </div>\n
#line 899 "pageelems.ecpp"
 if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[294]; //   <div class="scraper_list"><a href ="
#line 900 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[295]; // " target="_blank">
#line 900 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[296]; // </a></div>\n
#line 901 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[297]; //   <div class="scraper_list">
#line 902 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[298]; //    
#line 902 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[299]; // </div>\n
#line 903 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[300]; //   <div class="scraper_list">
#line 904 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[301]; //         
#line 904 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), scraperMovieOrTv.runtime*60) );
  reply.out() << _tntChunks[302]; // </div>\n
#line 905 "pageelems.ecpp"
 }

#line 906 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[303]; //   <div class="scraper_list">
#line 909 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[304]; //      
#line 909 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[305]; // </div>\n
#line 910 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[306]; //   <div class="scraper_list">
#line 914 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[307]; //  
#line 914 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[308]; //  / 
#line 914 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount) );
  reply.out() << _tntChunks[309]; // </div>\n
#line 915 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[310]; // \n
#line 921 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[311]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 923 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[312]; // " target="_blank"> 
#line 923 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[313]; //  </a>\n    </div>\n
#line 925 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[314]; // \n
#line 930 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[315]; //     <div class="scraper_list">
#line 934 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[316]; //          
#line 934 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[317]; // </div>\n
#line 935 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[318]; //     <div class="scraper_list">
#line 939 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[319]; //         
#line 939 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[320]; // </div>\n
#line 940 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[321]; // \n
#line 946 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[322]; //     <div class="scraper_list">
#line 949 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[323]; //  
#line 949 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[324]; // </div>\n
#line 950 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[325]; //     <div class="scraper_list">
#line 954 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[326]; //          
#line 954 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[327]; // </div>\n
  reply.out() << _tntChunks[328]; // \n
#line 958 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[329]; //     <div class="scraper_list">
#line 970 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[330]; // </div>\n    <table>\n
#line 972 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 973 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[331]; //       <tr>\n        <td class="cast_role"> 
#line 975 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[332]; //  </td>\n        <td> 
#line 976 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[333]; //  </td>\n      </tr>\n
#line 978 "pageelems.ecpp"
   }

#line 979 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 980 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 981 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[334]; //         <tr>\n          <td class="cast_role"> 
#line 983 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[335]; //  </td>\n          <td> 
#line 984 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[336]; //  </td>\n        </tr>\n
#line 986 "pageelems.ecpp"
     }

#line 987 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 988 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[337]; //         <tr>\n          <td class="cast_role"> 
#line 990 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[338]; //  </td>\n          <td> 
#line 991 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[339]; //  </td>\n        </tr>\n
#line 993 "pageelems.ecpp"
     }

#line 994 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[340]; //   </table>\n
#line 996 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[341]; // </div>\n
  reply.out() << _tntChunks[342]; // \n<div id = '
#line 1002 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[343]; // _actors' hidden>\n
#line 1003 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[344]; // <table>\n
#line 1007 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string loc_name = std::locale("").name().substr(0,2);
  if (loc_name.length() != 2 || loc_name[0] == 'C' || loc_name[0] == '*') loc_name = "en"; //  use en as default
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[345]; //       <tr>\n
#line 1019 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[346]; //     <td>\n      <a href="/tvscraper/
#line 1021 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[347]; // " target="_blank">\n        <img src="/tvscraper/
#line 1022 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[348]; // " alt="
#line 1022 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[349]; // : 
#line 1022 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[350]; // " class="actor" />\n      </a>\n    </td>\n
#line 1025 "pageelems.ecpp"

    stringAppend(actor_names, "<td><a href=\"https://", loc_name, ".wikipedia.org/wiki/",
      StringUrlEncode(StringReplace(character->getPersonName(), " ", "_")), "\" target=\"_blank\">",
      character->getPersonName(), "</a>");
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[351]; //       </tr>\n      <tr>
#line 1035 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[352]; // </tr>\n
#line 1036 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[353]; //     </tr>\n    <tr>
#line 1045 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[354]; // </tr>\n
#line 1046 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[355]; // </table>\n
#line 1050 "pageelems.ecpp"

}

  reply.out() << _tntChunks[356]; // </div>\n
  reply.out() << _tntChunks[357]; // \n<div id = '
#line 1055 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[358]; // _artwork' hidden>\n
#line 1056 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 1061 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 1061 "pageelems.ecpp"
    _tnt_cq33.add( "media_p", (media_p));
#line 1061 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[359]; // \n
  // <& media ...
  { 
#line 1062 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 1062 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_f));
#line 1062 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[360]; // \n
  // <& media ...
  { 
#line 1063 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 1063 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_b));
#line 1063 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[361]; // \n</div>\n
  reply.out() << _tntChunks[362]; // \n<div id = '
#line 1066 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[363]; // _epg'>\n\t\t\t\t\t
#line 1067 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[364]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 1080 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[367]; //   <a href="/tvscraper/
#line 1084 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[368]; // " target="_blank">\n    <img src="/tvscraper/
#line 1085 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[369]; // " class="artwork" />\n  </a>\n
#line 1087 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 53 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[371]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 1096 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[372]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1100 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[373]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1101 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[374]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 1103 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[375]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 1105 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[376]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 1107 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[377]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 1109 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[378]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 1111 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[379]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 1113 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[380]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1115 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[381]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1116 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[382]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1117 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1117 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[383]; // </div>\n\t\t\t\t<div class="about_left">
#line 1118 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[384]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1119 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[385]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1120 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[386]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 1123 "pageelems.ecpp"
					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[387]; // \t\t\t\t\t<img align="center" src="
#line 1124 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[388]; // "/>\n
#line 1125 "pageelems.ecpp"
					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[389]; // \t\t\t\t\t\t
#line 1126 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[390]; // : 
#line 1126 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[391]; // \n
#line 1127 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[392]; // \t\t\t\t\t\t
#line 1128 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[393]; // : 
#line 1128 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[394]; // \n
#line 1129 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[395]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1130 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[396]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 1134 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[397]; // \t\t\t\t\t<img align="center" src="
#line 1137 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[398]; // "/>\n
#line 1138 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[399]; // \t\t\t\t\t\t
#line 1141 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[400]; // : 
#line 1141 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[401]; // \n
#line 1142 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[402]; // \t\t\t\t\t\t
#line 1145 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[403]; // : 
#line 1145 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[404]; // \n
#line 1146 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[405]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1149 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[406]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">tvscraper:</div>\n\t\t\t\t<div class="about_right">\n
#line 1153 "pageelems.ecpp"
					Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[407]; // \t\t\t\t\t<img align="center" src="
#line 1154 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[408]; // "/>\n
#line 1155 "pageelems.ecpp"
					if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[409]; // \t\t\t\t\t\t
#line 1156 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[410]; // : 
#line 1156 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[411]; // \n
#line 1157 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[412]; // \t\t\t\t\t\t
#line 1158 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[413]; // : 
#line 1158 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[414]; // \n
#line 1159 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[415]; // \t\t\t\t\t(<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1160 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[416]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1162 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[417]; // </div></div></div>\n\t\t\t\t<div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them</a></div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1165 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[418]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 1166 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[419]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
